void draw() {
  
  lights();
  
  pushStyle();
  pushMatrix();
  
  colorMode(RGB, 1f);
  background(0);

//  fill(1f, 1f, 1f, .1f);
//  noFill();
//  stroke(.2f);
//  sphereDetail(30);
//  sphere(240); // a big sphere

  noStroke();
//  gnDataLength = 10;
  for( int i=0; i<gnDataLength; i++ )  {
    gTransactions[i].draw(gnCurrentMode);
  }
  
  popMatrix();
  popStyle();
  
  drawLabels();
}

void drawLabels()
{
  // Static text
  cam.beginHUD();
  textAlign(LEFT, CENTER);
  emissive(255);
  fill(255);
  textFont(gFont2);
  text("Earth", 30, 30);
  textFont(gFont1);
  emissive(150);
  fill(150);
  text("Data mining from Seattle Public Library 2005-2011", 30, 50);
  textAlign(RIGHT, CENTER);
  textFont(gFont3);
  text("MAT259, Data Visualization", 1004, 715);
  text("Final Project: 3D Visualization", 1004, 730);
  text("By Yoon Chung Han", 1004, 745);
  text("Press key 1-5", 1004, 50);
  text("1 : Full sphere, 2 : Lines, 3: Spheres", 1004, 65);
  text("4: Spheres with Dates text, 5: Book title texts", 1004, 80);
  
  //Dewey class text
  colorMode(RGB, 255, 255, 255, 100);
  textAlign(LEFT, CENTER);
  textFont(gFont1);
  text("Dewey Class Color", 30, 70);
  emissive(255,0,0);
  fill(255,0,0,100);
  text("000 - 99 : Information & Computer Science", 30, 90);
  text("100 - 199 : Philosophy & Psychology", 30, 105);
  emissive(205,71,55);
  fill(205,71,55, 100);
  text("200 - 299 : Religion", 30, 120);
  emissive(143,17,140);
  fill(211,57,138, 100);
  text("300 - 349 : Social Sciences", 30, 135);
  emissive(255,134,0);
  fill(255,134,0, 100);
  text("350 - 399 : Social Sciences", 30, 150);
  emissive(0,253,181);
  fill(0,253,181, 100);
  text("400 - 449 : Languages", 30, 165);
  emissive(20,167,124);
  fill(20,167,124, 100);
  text("450 - 499 : Languages", 30, 180);
  emissive(50,131,75);
  fill(50,131,75, 100);
  text("500 - 599 : Science & Mathematics", 30, 195);
  emissive(0,189,255);
  fill(0,189,255, 100);
  text("600 - 699 : Technology & Applied Science", 30, 210);
  emissive(0,126,255);
  fill(0,126,255, 100);
  text("700 - 799 : Arts & Recreation", 30, 225);
  emissive(144,0,255);
  fill(144,0,255, 100);
  text("800 - 899 : Literature", 30, 240);
  emissive(143,17,140);
  fill(143,17,140, 100);
  text("900 - 999 : History & Geography & Biography", 30, 255);
  
  cam.endHUD();
}
